/*********************************************************
 *     The Milliways III System is copyright 1992        *
 *      J.S.Mitchell. (arthur@sugalaxy.swan.ac.uk)       *
 *       see licence for furthur information.            *
 *********************************************************/
#include <stdio.h>
#include <fcntl.h>
#include "../bb.h"

struct listing 
{
	char name[NAMESIZE+1];
	int count;
	int size;
	struct listing *next;
}Node;

#include "sort.c"

main(argc,argv)
int argc;
char **argv;
{
	struct listing *head;
	char fullpath[PATHSIZE];
	struct Header index;
	struct listing *new;
	struct listing *ptr;
	int file;
	int count;
	char buff[10];


	head=NULL;
	if (argc!=2)
	{
		fprintf(stderr,"Usage: %s <foldername>\n",argv[0]);
		exit(-1);
	}
	sprintf(fullpath,"%s/%s%s",HOMEPATH,argv[1],INDEX_END);
	if (access(fullpath,00))
	{
		fprintf(stderr,"Folder %s not found.\n",argv[1]);
		exit(-1);
	}
	if ((file=open(fullpath,O_RDONLY))<0)
	{
		perror(argv[0]);
		exit(-1);
	}
	new=(struct listing *)malloc(sizeof(*new));
	while(read(file,&index,sizeof(index))>0)
	{
		struct listing *ptr;
		ptr=head;
		while (ptr!=NULL && strcmp(index.from,ptr->name))
		{ptr=ptr->next;}
		if (ptr!=NULL)
		{
			ptr->count++;
		 	ptr->size+=index.size;
		}
		else
		{
			strcpy(new->name,index.from);
			new->count=1;
			new->size=index.size;
			new->next=head;
			head=new;
			new=(struct listing *)malloc(sizeof(*new));
		}
	}
	head=Sort(head);

printf("Top posters in folder %s\n",argv[1]);
printf("In order of Total size of text posted.\n");
	ptr=head;
count=2;
	while (ptr!=NULL)
	{
		printf("Name: %*s   %3d Msgs.   %5d bytes (%2.1fK)\n",NAMESIZE,ptr->name,ptr->count,ptr->size,ptr->size/1024.0);
		ptr=ptr->next;
		count++;
		if (count>=22)
		{
			printf("---more---\r");
			gets(buff);
			printf("          \r");
			if (*buff=='q' || *buff=='Q') exit(0);
			count=0;
		}
	}
}
